const Crke_PrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
const Crke_Branch = Crke_PrefService.getBranch("crke.");

  // je toolbar aktiven?
  if(!Crke_Branch.prefHasUserValue("stanje"))
  {
     Crke_Branch.setBoolPref("stanje", true);
  }

  // shranjeno stanje vidnosti crk
  if(!Crke_Branch.prefHasUserValue("vidnost"))
  {
    Crke_Branch.setCharPref("vidnost", "11111111111111111111111111111");
  }

const imenaCrk = "abc1defghijklmnopqrs2tuvwxyz3";




// pripravi podatke ko se toolbar nalozi prvic
function crke_zacni()
{
    // ce je toolbar nekativen, to oznaci
    if(!Crke_Branch.getBoolPref("stanje"))
    {
       var zamenjaj = document.getElementById("CrkeTB-info");
       zamenjaj.setAttribute("class", "CrkeTB-info-pasiven");
       zamenjaj = document.getElementById("CrkeTB-spremeni");
       zamenjaj.setAttribute("label", "poka\u017ei \u00b7 show \u00b7 \u663e\u793a");
    }

  var windowContent = window.document.getElementById("content");

    if(windowContent)
    {
       var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService().QueryInterface(Components.interfaces.nsIConsoleService);
       var tabBox = windowContent.mTabBox;

       // dodat TRY ...
       windowContent.addEventListener("load", crke_dodajCrkePovsod, true);
       windowContent.addEventListener("keypress", crke_tipkanje, false);

         if(tabBox)
         {
           // tabBox.addEventListener("select", crke_dodajCrkePovsod, true);
         }

      try
      {
        window.removeEventListener("load", crke_zacni, true);
      }
      catch(exception)
      {
      // ne naredi ni
      }

    }
}



// doda crke v vse dokumente - zanka preko dokumentov
function crke_dodajCrkePovsod()
{
  var documentList   = crke_getDocuments(crke_getContentWindow());
  var documentLength = documentList.length;

    // zanka cez vse dokukumente
    for(var i = 0; i < documentLength; i++)
    {
      var pageDocument = documentList[i];

      var bodyList = pageDocument.documentElement.getElementsByTagName('body');
      var body = bodyList[0];
      
        // nekateri documenti nimajo body-ja (npr. frameset)
        if (body != undefined) {crke_dodajCrke(documentList[i], body);}
    }
}



// doda crke v 'document'
function crke_dodajCrke(dokument, telo)
{
  // doda crke, ce jih se ni
  if (dokument.getElementById("crkeID-crka--a") == null)
  {
     var contentWindow = getBrowser().contentWindow;
     var levo = (contentWindow.innerWidth / 2 ) - 300;
     
     var zgoraj = 75;
     var poravnaj = 0;
     var crkeVidne = "";
     var kateraCrka="";
     
       for (var i=0;i<=28;i++)
       {
          kateraCrka=imenaCrk.charAt(i);
          var dodajDiv = dokument.createElement("div");
          dodajDiv.setAttribute("id", "crkeID-crka--" + kateraCrka);

            if (!Crke_Branch.getBoolPref("stanje")){crkeVidne = "hidden"}
            else
            {
               crkeVidne = Crke_Branch.getCharPref("vidnost").charAt(i) == "1" ? "visible" : "hidden";
            }

          dodajDiv.setAttribute("style", "visibility: " + crkeVidne + "; position: absolute; z-index: " + i+ "; width: 100px; height: 100px; top: " + zgoraj + "px; left: " + levo + "px; cursor: move; background-image: url('chrome://crke/skin/crke/" + kateraCrka + ".gif'); background-repeat: no-repeat; background-color: transparent;");
          
          crkeVidne = Crke_Branch.getCharPref("vidnost").charAt(i) == "1" ? "visible" : "hidden";
          dodajDiv.setAttribute("class", "crke-" + crkeVidne);

          poravnaj += 1;
            if (poravnaj == 6){poravnaj = 0; levo-=600; zgoraj+=100;}
          levo += 100;

          telo.appendChild(dodajDiv);

            try
            {
              dodajDiv.addEventListener("mousedown", crke_izberiCrko, true);
            }
            catch(exception)
            {
              // nic
            }
       }
  }
}



function crke_tipkanje(e)
{
  if(e.ctrlKey || e.altKey)
  {
     return;
  }

  var ownerDocument = e.target.ownerDocument;
  // ownerDocument' ni nujno 'html' ampak npr. [object XulDocument], ce je fokus na zavihku
  if(!ownerDocument.getElementById("crkeID-crka--a"))
  {
     return;
  }

  var rezultat = e.charCode;
  var znak =  String.fromCharCode(rezultat);
  var spremeniVidnost="";

    if (rezultat >= 65 && rezultat <= 90) spremeniVidnost = znak.toLowerCase();
    else if (rezultat == 269 || rezultat == 268) spremeniVidnost = "1";
    else if (rezultat == 353 || rezultat == 352) spremeniVidnost = "2";
    else if (rezultat == 382 || rezultat == 381) spremeniVidnost = "3";
    else if (rezultat >= 97 && rezultat <= 122) spremeniVidnost = znak;

  if(spremeniVidnost != "")
  {
    if (Crke_Branch.getBoolPref("stanje"))
    {
      var vidnost = ownerDocument.getElementById("crkeID-crka--" + spremeniVidnost).style.visibility == "hidden" ? "visible" : "hidden";
      ownerDocument.getElementById("crkeID-crka--" + spremeniVidnost).style.visibility = vidnost;
      ownerDocument.getElementById("crkeID-crka--" + spremeniVidnost).setAttribute("class", "crke-"+vidnost);
    }
  }
}




function crke_SpremeniStanje()
{
   var spremeni = Crke_Branch.getBoolPref("stanje") == true ? false : true;
   Crke_Branch.setBoolPref("stanje", spremeni);
   crke_SpremeniVidnost(spremeni);
}



// shrani podatke, ko se okno zapre
function crke_KoSeZapre()
{
   var oken = 0;
   var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
   var enumerator = wm.getEnumerator(null);
     while(enumerator.hasMoreElements())
     {
        var test = enumerator.getNext()
        oken++;

          // ignoriraj okna, ki nimajo toolbara
          if(!test.document.getElementById("CrkeTB-info"))
          {
             oken--;
          }
     }

   if (oken > 1)
   {
      return;
   }

  // shrani stanje aktivnosti
  var aktiven = document.getElementById("CrkeTB-info").getAttribute("class");

    if (aktiven == "CrkeTB-info-aktiven"){
       Crke_Branch.setBoolPref("stanje", true);
    }
    else
    {
       Crke_Branch.setBoolPref("stanje", false);
    }

   // shrani vidnost crk
   var nasel = false;
   var shrani = gBrowser.selectedBrowser.contentDocument;
   var bodyList = shrani.documentElement.getElementsByTagName('body');
   var body = bodyList[0];
     if (body != undefined)
     {
        var shranito = shrani;
        nasel = true;
     }
     else
     {
       var shrani = gBrowser.selectedBrowser.contentWindow;
       var documentList = crke_getDocuments(shrani);
       var documentLength = documentList.length;

         // zanka cez vse dokukumente
         for(var ii = 0; ii < documentLength; ii++)
         {
            var pageDocument = documentList[ii];
            var bodyList = pageDocument.documentElement.getElementsByTagName('body');
            var body = bodyList[0];

              if (body != undefined)
              {
                 //shrani zadnjega od vseh dokumentov ... enega je pac treba
                 // morda bi preveril kateri je navecji?
                 var shranito = pageDocument;
                 nasel = true;
              }
          }
     }

     shrani = "";
     if(nasel)
     {
          for (var i=0;i<=28;i++)
          {
             var kateraCrka = imenaCrk.charAt(i);
              shrani += shranito.getElementById("crkeID-crka--" + kateraCrka).getAttribute("class") == "crke-visible" ? "1" : "0";
          }
     }

     // ce se nic ne vidi (ali ce ni dokumenta), pokazi vse
     if(shrani.indexOf("1") == -1) shrani = "11111111111111111111111111111";

   Crke_Branch.setCharPref("vidnost", shrani);
}


function crke_oCrkah()
{
   window.openDialog("chrome://crke/content/ocrkah/ocrkah.xul", "ocrkah", "centerscreen,chrome,modal");
}


window.addEventListener("load", crke_zacni, true);
window.addEventListener("close", crke_KoSeZapre, true);
